// Exemple de cration de deux thread qui affichent un caractre different en parallele et une IHM qui permet de gerer l'execution des deux threads
//
import fr.cnam.ihm.*;

public class Exemple25 implements FormulaireInt
{
    private Formulaire form;
    private MonThread t1;
    private MonThread t2;
    private MonThread t3;

    public Exemple25()
    {
        form = new Formulaire("Thread",
                              this,
                              false,
                              600,600,true);
        
        form.addButton("SUSP1","Suspendre le thread 1",-1,-1,500);
        form.addButton("SUSP2","Suspendre le thread 2",-1,-1,500);
        form.addButton("REPR1","Reprendre le thread 1",-1,-1,500);
        form.addButton("REPR2","Reprendre le thread 2",-1,-1,500);
        int x = form.getXCour();
        int y = form.getYCour();
        form.addText("TIMESLEEP","Time sleep",true,""+MonThread.timeSleep,
                     x,y,100,5,40);
        form.addButton("VALIDER_TIMESLEEP","Valider",
                       x+150,y,120);
        form.addButton("EXCLUSIF","Bascule exclusif",x,-1,300);
        form.addButton("STOP1","Stopper le thread 1",-1,-1,500);
        form.addButton("STOP2","Stopper le thread 2",-1,-1,500);
        x = form.getXCour();
        y = form.getYCour();
        form.addText("DATA","Val commun thread",true,MonThread.paramGen1,
                     x,y,150,5,30);
        form.addButton("VALIDER_DATA","Valider",
                       x+170,y,120);

        form.afficher();

        // Creation des deux threads
        //
        t1 = new MonThread('X');
        t2 = new MonThread('-');
        t3 = new MonThread('/');

        // Demarrage des deux threads
        //
        t1.start();
        t2.start();
        t3.start();

    }

    public static void main(String[] args)
    {
        Exemple25 exemple = new Exemple25();
    }

    public void submit(Formulaire f,String nomBouton)
    {
        if (nomBouton.equals("SUSP1"))
            t1.suspendre();

        if (nomBouton.equals("SUSP2"))
            t2.suspendre();

        if (nomBouton.equals("REPR1"))
            t1.reprendre();

        if (nomBouton.equals("REPR2"))
            t2.reprendre();
        
        if (nomBouton.equals("VALIDER_TIMESLEEP"))
            {
                int value = Integer.parseInt(f.getValeurChamp("TIMESLEEP"));
                MonThread.setTimeSleep(value);
            }

        if (nomBouton.equals("EXCLUSIF"))
            MonThread.exclusion = ! MonThread.exclusion;

        if (nomBouton.equals("STOP1"))
             t1.stopper();

        if (nomBouton.equals("STOP2"))
             t2.stopper();

        if (nomBouton.equals("VALIDER_DATA"))
            {
                MonThread.paramGen1 = f.getValeurChamp("DATA");
            }

    }
}

