import java.util.Random;

// Exemple type d'un thread dont le traitement est cyclique
//
public class MonThread extends Thread
{
    // Exclusion de l'itration 
    final static Integer verrou = new Integer(0);  
    public static boolean exclusion = false;

    // Un paramettre commun  tous les threads
    static public String paramGen1 = "";   

    // Temps d'arret du thread
    static public int timeSleep = 1000;     

    // Parametre du thread (propre  chaque thread)
    char   param1;         

    // Arret du thread (propre  chaque thread)
    boolean stop;           

    // Pour suspendre le thread (propre  chaque thread)
    boolean suspend;        

    // Constructeur du thread
    //
    public MonThread(char param1)
    {
        this.stop    = false;
        this.suspend = false;
        
        this.param1 = param1;
    }
    
    // Traitement du Thread : la mthode run
    //  
    public void run()
    {
        while(! this.stop)
            {
                // La mthode run ne peut pas retourner d'exception
                try{

                    if (!exclusion) traitement1(20);
                    else traitement2(20);

                    // Toujours laisser du temps au sequenceur
                    try{
                        Thread.sleep(timeSleep);
                    }catch(Exception ex){};

                    // Pour suspendre le thread
                    synchronized(this)
                        {
                            while (suspend && !stop) 
                                {
                                        wait();
                                }
                        }
                }
                catch(Exception ex)
                    {
                        //Erreur sur l'itration du traitement
                    }
            }
    }

    // Ce traitement n'est pas synchrone
    //
    private void traitement1(int nb)
    {
        for(int i=0;i<nb;i++)
            {
                System.out.print(""+param1+paramGen1);
                System.out.flush();
                try{Thread.sleep(30);}catch(Exception ex){};
            }
        System.out.println();
    }

    // Ce traitement est synchrone
    //
    private void traitement2(int nb)
    {
        synchronized(verrou)
            {
                for(int i=0;i<nb;i++)
                    {
                        System.out.print(""+param1+paramGen1);
                        System.out.flush();
                        try{Thread.sleep(40);}catch(Exception ex){};
                    }
                System.out.println();
            }
    }

    // Stoppe le thread qui s'arrte
    //
    public void stopper()
    {
        this.stop=true;
    }

    // Suspendre le thread
    //   (la mthode run se met en wait sur le thread)
    //
    public void suspendre()
    {
        this.suspend=true;
    }

    // Reprendre le thread
    //   
    public void reprendre()
    {
        synchronized(this)
            {
                notify();  // libre le wait
            }
        this.suspend=false;
    }

    // Tempo entre chaque itration de la mthode thread
    //
    synchronized static void setTimeSleep(int timeSleep_p)
    {
        timeSleep = timeSleep_p;
    }
}

